码迷,mamicode.com
首页 > 系统相关 > 详细

ubuntu14.04 安装tensorflow始末

时间:2019-03-26 21:08:36      阅读:876      评论:0      收藏:0      [点我收藏+]

标签:his   project   rgs   was   roo   with   clob   list   pac   

基于ubuntu14.04 干净的系统一步步遇到的坑记录下来;

怀着平静学习的心情,问题总的能解决的!

 

1. 首先看了下当前python版本

python --version
Python 2.7.6

 2. 安装pip

  先更新源

 sudo apt-get update

 sudo apt-get upgrade

  安装pip

  

 sudo apt-get install python-pip

  查看pip 版本

  pip -V
  pip 1.5.4 from /usr/lib/python2.7/dist-packages (python 2.7)

 

3.  尝试安装tensorflow,本以为安装就这么简单完成了:

[email protected]:/opt/work/lazyzoon$ pip install tensorflow
Downloading/unpacking tensorflow
  Could not find any downloads that satisfy the requirement tensorflow
Cleaning up...
No distributions at all found for tensorflow
Storing debug log for failure in /home/tyler/.pip/pip.log

 

现在开始报错了

 (1). 首先怀疑的是pip版本太低,想先升级pip版本

  [email protected]:/opt/work/lazyzoon$ pip install pip -U
Downloading/unpacking pip from https://files.pythonhosted.org/packages/d8/f3/413bab4ff08e1fc4828dfc59996d721917df8e8583ea85385d51125dceff/pip-19.0.3-py2.py3-none-any.whl#sha256=bd812612bbd8ba84159d9ddc0266b7fbce712fc9bc98c82dee5750546ec8ec64
  Downloading pip-19.0.3-py2.py3-none-any.whl (1.4MB): 1.4MB downloaded
Installing collected packages: pip
  Found existing installation: pip 1.5.4
    Not uninstalling pip at /usr/lib/python2.7/dist-packages, owned by OS
  Can‘t roll back pip; was not uninstalled
Cleaning up...
Exception:
Traceback (most recent call last):
  File "/usr/lib/python2.7/dist-packages/pip/basecommand.py", line 122, in main
    status = self.run(options, args)
  File "/usr/lib/python2.7/dist-packages/pip/commands/install.py", line 283, in run
    requirement_set.install(install_options, global_options, root=options.root_path)
  File "/usr/lib/python2.7/dist-packages/pip/req.py", line 1436, in install
    requirement.install(install_options, global_options, *args, **kwargs)
  File "/usr/lib/python2.7/dist-packages/pip/req.py", line 672, in install
    self.move_wheel_files(self.source_dir, root=root)
  File "/usr/lib/python2.7/dist-packages/pip/req.py", line 902, in move_wheel_files
    pycompile=self.pycompile,
  File "/usr/lib/python2.7/dist-packages/pip/wheel.py", line 206, in move_wheel_files
    clobber(source, lib_dir, True)
  File "/usr/lib/python2.7/dist-packages/pip/wheel.py", line 193, in clobber
    os.makedirs(destsubdir)
  File "/usr/lib/python2.7/os.py", line 157, in makedirs
    mkdir(name, mode)
OSError: [Errno 13] Permission denied: ‘/usr/local/lib/python2.7/dist-packages/pip‘

Storing debug log for failure in /home/tyler/.pip/pip.log

  没办法,只能换种方法升级pip,各种google,百度,找到下面这种方法升级成功

  下载这个py脚本

wget https://bootstrap.pypa.io/get-pip.py  --no-check-certificate

  然后执行

sudo python get-pip.py

[email protected]:/opt/work/lazyzoon$ sudo python get-pip.py
DEPRECATION: Python 2.7 will reach the end of its life on January 1st, 2020. Please upgrade your Python as Python 2.7 wont be maintained after that date. A future version of pip will drop support for Python 2.7.
The directory /home/tyler/.cache/pip/http or its parent directory is not owned by the current user and the cache has been disabled. Please check the permissions and owner of that directory. If executing pip with sudo, you may want sudos -H flag.
The directory /home/tyler/.cache/pip or its parent directory is not owned by the current user and caching wheels has been disabled. check the permissions and owner of that directory. If executing pip with sudo, you may want sudos -H flag.
Collecting pip
/tmp/tmp5OMysZ/pip.zip/pip/_vendor/urllib3/util/ssl_.py:354: SNIMissingWarning: An HTTPS request has been made, but the SNI (Server Name Indication) extension to TLS is not available on this platform. This may cause the server to present an incorrect TLS certificate, which can cause validation failures. You can upgrade to a newer version of Python to solve this. For more information, see https://urllib3.readthedocs.io/en/latest/advanced-usage.html#ssl-warnings
/tmp/tmp5OMysZ/pip.zip/pip/_vendor/urllib3/util/ssl_.py:150: InsecurePlatformWarning: A true SSLContext object is not available. This prevents urllib3 from configuring SSL appropriately and may cause certain SSL connections to fail. You can upgrade to a newer version of Python to solve this. For more information, see https://urllib3.readthedocs.io/en/latest/advanced-usage.html#ssl-warnings
/tmp/tmp5OMysZ/pip.zip/pip/_vendor/urllib3/util/ssl_.py:150: InsecurePlatformWarning: A true SSLContext object is not available. This prevents urllib3 from configuring SSL appropriately and may cause certain SSL connections to fail. You can upgrade to a newer version of Python to solve this. For more information, see https://urllib3.readthedocs.io/en/latest/advanced-usage.html#ssl-warnings
  Downloading https://files.pythonhosted.org/packages/d8/f3/413bab4ff08e1fc4828dfc59996d721917df8e8583ea85385d51125dceff/pip-19.0.3-py2.py3-none-any.whl (1.4MB)
    100% |████████████████████████████████| 1.4MB 3.0MB/s
Installing collected packages: pip
  Found existing installation: pip 1.5.4
    Uninstalling pip-1.5.4:
      Successfully uninstalled pip-1.5.4
Successfully installed pip-19.0.3

 

这样就安装成功了pip新版本

[email protected]:/opt/work/lazyzoon$ pip -V
pip 19.0.3 from /usr/local/lib/python2.7/dist-packages/pip (python 2.7)

 (2). 继续尝试安装tensorfolw,还是报错

 

sudo pip install tensorflow

markdown 3.1 has requirement setuptools>=36, but youll have setuptools 3.3 which is incompatible.
Installing collected packages: numpy, six, enum34, futures, grpcio, h5py, keras-applications, markdown, werkzeug, protobuf, absl-py, tensorboard, termcolor, gast, funcsigs, pbr, mock, tensorflow-estimator, backports.weakref, astor, keras-preprocessing, tensorflow
  Found existing installation: six 1.5.2
Cannot uninstall six. It is a distutils installed project and thus we cannot accurately determine which files belong to it which would lead to only a partial uninstall.

然后发现我们本地还有python3 版本

[email protected]:/opt/work/lazyzoon$ python3 -V
Python 3.4.3

想着把python也用新版本

为了保险起见,我把之前用python2.7安装的pip卸载了

sudo apt-get remove python-pip
Reading package lists... Done
Building dependency tree       
Reading state information... Done
The following packages were automatically installed and are no longer required:
  libdbusmenu-gtk4 libqpdf13 python-chardet-whl python-colorama
  python-colorama-whl python-distlib python-distlib-whl python-html5lib
  python-html5lib-whl python-pip-whl python-requests-whl python-setuptools-whl
  python-six-whl python-urllib3-whl python-wheel
Use apt-get autoremove to remove them.
The following packages will be REMOVED:
  python-pip
0 upgraded, 0 newly installed, 1 to remove and 3 not upgraded.
After this operation, 477 kB disk space will be freed.
Do you want to continue? [Y/n] Y
(Reading database ... 220957 files and directories currently installed.)
Removing python-pip (1.5.4-1ubuntu4) ...


但是我发现我卸载的好像是1.5.4版本,可能这个尝试是多余。。

不管三七二十一了,用python3继续安装

[email protected]:/opt/work/lazyzoon$ sudo python3 get-pip.py
DEPRECATION: Python 3.4 support has been deprecated. pip 19.1 will be the last one supporting it. Please upgrade your Python as Python 3.4 won‘t be maintained after March 2019 (cf PEP 429).
The directory ‘/home/tyler/.cache/pip/http‘ or its parent directory is not owned by the current user and the cache has been disabled. Please check the permissions and owner of that directory. If executing pip with sudo, you may want sudo‘s -H flag.
The directory ‘/home/tyler/.cache/pip‘ or its parent directory is not owned by the current user and caching wheels has been disabled. check the permissions and owner of that directory. If executing pip with sudo, you may want sudo‘s -H flag.
Collecting pip
  Downloading https://files.pythonhosted.org/packages/d8/f3/413bab4ff08e1fc4828dfc59996d721917df8e8583ea85385d51125dceff/pip-19.0.3-py2.py3-none-any.whl (1.4MB)
    100% |████████████████████████████████| 1.4MB 10.6MB/s
Collecting setuptools
  Downloading https://files.pythonhosted.org/packages/d1/6a/4b2fcefd2ea0868810e92d519dacac1ddc64a2e53ba9e3422c3b62b378a6/setuptools-40.8.0-py2.py3-none-any.whl (575kB)
    100% |████████████████████████████████| 583kB 12.5MB/s
Collecting wheel
  Downloading https://files.pythonhosted.org/packages/96/ba/a4702cbb6a3a485239fbe9525443446203f00771af9ac000fa3ef2788201/wheel-0.33.1-py2.py3-none-any.whl
Installing collected packages: pip, setuptools, wheel
Successfully installed pip-19.0.3 setuptools-40.8.0 wheel-0.33.1

也提示安装成功了

现在多了一个pip3,用pip3安装试试

sudo pip3 install tensorflow

DEPRECATION: Python 3.4 support has been deprecated. pip 19.1 will be the last one supporting it. Please upgrade your Python as Python 3.4 wont be maintained after March 2019 (cf PEP 429).
The directory /home/tyler/.cache/pip/http or its parent directory is not owned by the current user and the cache has been disabled. Please check the permissions and owner of that directory. If executing pip with sudo, you may want sudos -H flag.
The directory /home/tyler/.cache/pip or its parent directory is not owned by the current user and caching wheels has been disabled. check the permissions and owner of that directory. If executing pip with sudo, you may want sudos -H flag.
Collecting tensorflow
  Downloading https://files.pythonhosted.org/packages/37/f0/7b2fd5c7cddb3f7f11e7859850f543e19009761cdb965ed8bd98f66d60fd/tensorflow-1.13.1-cp34-cp34m-manylinux1_x86_64.whl (93.2MB)
    25% |████████▎                       | 24.1MB 91kB/s eta 0:12:37Exception:
Traceback (most recent call last):
  File "/usr/local/lib/python3.4/dist-packages/pip/_vendor/urllib3/response.py", line 360, in _error_catcher
    yield
  File "/usr/local/lib/python3.4/dist-packages/pip/_vendor/urllib3/response.py", line 442, in read
    data = self._fp.read(amt)
  File "/usr/local/lib/python3.4/dist-packages/pip/_vendor/cachecontrol/filewrapper.py", line 62, in read
    data = self.__fp.read(amt)
  File "/usr/lib/python3.4/http/client.py", line 529, in read
    return super(HTTPResponse, self).read(amt)
  File "/usr/lib/python3.4/http/client.py", line 568, in readinto
    n = self.fp.readinto(b)
  File "/usr/lib/python3.4/socket.py", line 374, in readinto
    return self._sock.recv_into(b)
  File "/usr/lib/python3.4/ssl.py", line 769, in recv_into
    return self.read(nbytes, buffer)
  File "/usr/lib/python3.4/ssl.py", line 641, in read
    v = self._sslobj.read(len, buffer)
socket.timeout: The read operation timed out

During handling of the above exception, another exception occurred:

Traceback (most recent call last):
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/cli/base_command.py", line 179, in main
    status = self.run(options, args)
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/commands/install.py", line 315, in run
    resolver.resolve(requirement_set)
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/resolve.py", line 131, in resolve
    self._resolve_one(requirement_set, req)
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/resolve.py", line 294, in _resolve_one
    abstract_dist = self._get_abstract_dist_for(req_to_install)
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/resolve.py", line 242, in _get_abstract_dist_for
    self.require_hashes
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/operations/prepare.py", line 334, in prepare_linked_requirement
    progress_bar=self.progress_bar
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/download.py", line 878, in unpack_url
    progress_bar=progress_bar
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/download.py", line 702, in unpack_http_url
    progress_bar)
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/download.py", line 946, in _download_http_url
    _download_url(resp, link, content_file, hashes, progress_bar)
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/download.py", line 639, in _download_url
    hashes.check_against_chunks(downloaded_chunks)
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/utils/hashes.py", line 62, in check_against_chunks
    for chunk in chunks:
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/download.py", line 607, in written_chunks
    for chunk in chunks:
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/utils/ui.py", line 159, in iter
    for x in it:
  File "/usr/local/lib/python3.4/dist-packages/pip/_internal/download.py", line 596, in resp_read
    decode_content=False):
  File "/usr/local/lib/python3.4/dist-packages/pip/_vendor/urllib3/response.py", line 494, in stream
    data = self.read(amt=amt, decode_content=decode_content)
  File "/usr/local/lib/python3.4/dist-packages/pip/_vendor/urllib3/response.py", line 459, in read
    raise IncompleteRead(self._fp_bytes_read, self.length_remaining)
  File "/usr/lib/python3.4/contextlib.py", line 77, in __exit__
    self.gen.throw(type, value, traceback)
  File "/usr/local/lib/python3.4/dist-packages/pip/_vendor/urllib3/response.py", line 365, in _error_catcher
    raise ReadTimeoutError(self._pool, None, Read timed out.)
pip._vendor.urllib3.exceptions.ReadTimeoutError: HTTPSConnectionPool(host=files.pythonhosted.org, port=443): Read timed out.

这个错误是网络不稳定导致的,再次执行结果还是报错:

[email protected]:/opt/work/lazyzoon$ sudo pip3 install tensorflow

Installing collected packages: six, protobuf, astor, numpy, keras-preprocessing, termcolor, markdown, grpcio, absl-py, werkzeug, tensorboard, pbr, mock, tensorflow-estimator, h5py, keras-applications, gast, tensorflow
  Found existing installation: six 1.5.2
Cannot uninstall six. It is a distutils installed project and thus we cannot accurately determine which files belong to it which would lead to only a partial uninstall.

好像是six模块的问题,需要更新安装

然后执行:

sudo pip install six --upgrade --target="/usr/local/lib/python3.4/dist-packages/"

DEPRECATION: Python 3.4 support has been deprecated. pip 19.1 will be the last one supporting it. Please upgrade your Python as Python 3.4 wont be maintained after March 2019 (cf PEP 429).
The directory /home/tyler/.cache/pip/http or its parent directory is not owned by the current user and the cache has been disabled. Please check the permissions and owner of that directory. If executing pip with sudo, you may want sudos -H flag.
The directory /home/tyler/.cache/pip or its parent directory is not owned by the current user and caching wheels has been disabled. check the permissions and owner of that directory. If executing pip with sudo, you may want sudos -H flag.
Collecting six
  Downloading https://files.pythonhosted.org/packages/73/fb/00a976f728d0d1fecfe898238ce23f502a721c0ac0ecfedb80e0d88c64e9/six-1.12.0-py2.py3-none-any.whl
Installing collected packages: six
Successfully installed six-1.12.0

成功更新了six

继续尝试安装tensorflow,果然没让我失望,还是报错

sudo pip3 install tensorflow

File "/tmp/pip-install-s_yz77x6/numpy/numpy/distutils/command/build_src.py", line 165, in build_sources
        self.build_extension_sources(ext)
      File "/tmp/pip-install-s_yz77x6/numpy/numpy/distutils/command/build_src.py", line 322, in build_extension_sources
        sources = self.generate_sources(sources, ext)
      File "/tmp/pip-install-s_yz77x6/numpy/numpy/distutils/command/build_src.py", line 375, in generate_sources
        source = func(extension, build_dir)
      File "numpy/core/setup.py", line 423, in generate_config_h
        moredefs, ignored = cocache.check_types(config_cmd, ext, build_dir)
      File "numpy/core/setup.py", line 47, in check_types
        out = check_types(*a, **kw)
      File "numpy/core/setup.py", line 281, in check_types
        "install {0}-dev|{0}-devel.".format(python))
    SystemError: Cannot compile Python.h. Perhaps you need to install python-dev|python-devel.
    
    ----------------------------------------
Command "/usr/bin/python3 -u -c "import setuptools, tokenize;__file__=/tmp/pip-install-s_yz77x6/numpy/setup.py;f=getattr(tokenize, open, open)(__file__);code=f.read().replace(\r\n, \n);f.close();exec(compile(code, __file__, exec))" install --record /tmp/pip-record-bie5c7mf/install-record.txt --single-version-externally-managed --compile" failed with error code 1 in /tmp/pip-install-s_yz77x6/numpy/

看着像是numpy模块问题,尝试更新numpy模块,然后又来一堆错误

[email protected]:/opt/work/lazyzoon$ pip install numpy

      File "/tmp/pip-install-5x9wvjol/numpy/numpy/distutils/command/build_src.py", line 322, in build_extension_sources
        sources = self.generate_sources(sources, ext)
      File "/tmp/pip-install-5x9wvjol/numpy/numpy/distutils/command/build_src.py", line 375, in generate_sources
        source = func(extension, build_dir)
      File "numpy/core/setup.py", line 423, in generate_config_h
        moredefs, ignored = cocache.check_types(config_cmd, ext, build_dir)
      File "numpy/core/setup.py", line 47, in check_types
        out = check_types(*a, **kw)
      File "numpy/core/setup.py", line 281, in check_types
        "install {0}-dev|{0}-devel.".format(python))
    SystemError: Cannot compile Python.h. Perhaps you need to install python-dev|python-devel.
    
    ----------------------------------------
Command "/usr/bin/python3 -u -c "import setuptools, tokenize;__file__=/tmp/pip-install-5x9wvjol/numpy/setup.py;f=getattr(tokenize, open, open)(__file__);code=f.read().replace(\r\n, \n);f.close();exec(compile(code, __file__, exec))" install --record /tmp/pip-record-571bsgcn/install-record.txt --single-version-externally-managed --compile" failed with error code 1 in /tmp/pip-install-5x9wvjol/numpy/

看提示可能是需要安装 python-dev

那就安装呗,sudo apt-get install python-dev

安装成功了python-dev

回来继续安装numpy

结果,还是和上次一样的报错

思考了下,我现在用的pip3,对应的python也是python3了,应该要安装 sudo apt-get install python3-dev 才对,

安装 python3-dev,

sudo apt-get install python3-dev

安装成功后,继续执行

[email protected]:/opt/work/lazyzoon$ sudo pip3 install numpy
DEPRECATION: Python 3.4 support has been deprecated. pip 19.1 will be the last one supporting it. Please upgrade your Python as Python 3.4 wont be maintained after March 2019 (cf PEP 429).
The directory /home/tyler/.cache/pip/http or its parent directory is not owned by the current user and the cache has been disabled. Please check the permissions and owner of that directory. If executing pip with sudo, you may want sudos -H flag.
The directory /home/tyler/.cache/pip or its parent directory is not owned by the current user and caching wheels has been disabled. check the permissions and owner of that directory. If executing pip with sudo, you may want sudos -H flag.
Collecting numpy
Installing collected packages: numpy
Successfully installed numpy-1.16.2

果然成功了

最后执行:

sudo pip3 install tensorflow

Collecting mock>=2.0.0 (from tensorflow-estimator<1.14.0rc0,>=1.13.0->tensorflow)
  Downloading https://files.pythonhosted.org/packages/e6/35/f187bdf23be87092bd0f1200d43d23076cee4d0dec109f195173fd3ebc79/mock-2.0.0-py2.py3-none-any.whl (56kB)
    100% |████████████████████████████████| 61kB 3.2MB/s
Collecting pbr>=0.11 (from mock>=2.0.0->tensorflow-estimator<1.14.0rc0,>=1.13.0->tensorflow)
  Downloading https://files.pythonhosted.org/packages/14/09/12fe9a14237a6b7e0ba3a8d6fcf254bf4b10ec56a0185f73d651145e9222/pbr-5.1.3-py2.py3-none-any.whl (107kB)
    100% |████████████████████████████████| 112kB 2.6MB/s
Installing collected packages: keras-preprocessing, werkzeug, absl-py, protobuf, grpcio, markdown, tensorboard, termcolor, gast, h5py, keras-applications, pbr, mock, tensorflow-estimator, tensorflow
  Running setup.py install for absl-py ... done
  Running setup.py install for termcolor ... done
  Running setup.py install for gast ... done
Successfully installed absl-py-0.7.1 gast-0.2.2 grpcio-1.19.0 h5py-2.9.0 keras-applications-1.0.7 keras-preprocessing-1.0.9 markdown-3.0.1 mock-2.0.0 pbr-5.1.3 protobuf-3.7.0 tensorboard-1.13.1 tensorflow-1.13.1 tensorflow-estimator-1.13.0 termcolor-1.1.0 werkzeug-0.15.1

到此安装tensorflow成功。

 

 

 

 

 

 

 

 

 



ubuntu14.04 安装tensorflow始末

标签:his   project   rgs   was   roo   with   clob   list   pac   

原文地址:https://www.cnblogs.com/lazyzoon/p/10603274.html

(0)
(1)
   
举报
评论 一句话评论(0
0条  
登录后才能评论!
© 2014 mamicode.com 版权所有 京ICP备13008772号-2
迷上了代码!